freeslot("S_UGRAT1", "S_UGRAT2", "S_UGRAT3", "S_UGRAT4", "SPR2_UGD1","SPR2_UGD2","SPR2_UGD3","SPR2_UGD4")


local function DanceString(str)-- if your message includes "dance" or "dancing" it returns true. It is also not case-sensitive meaning if you type "dAnCe", it will return true
    local lowercaseStr = string.lower(str)
    if string.find(lowercaseStr, "dance") or string.find(lowercaseStr, "dancing") then
        return true
    else
        return false
    end
end

uglystates[S_UGRAT1] = true
uglystates[S_UGRAT2] = true
uglystates[S_UGRAT3] = true
uglystates[S_UGRAT4] = true

rawset(_G, "uglyratstate", {
	[S_UGRAT1] = true,
	[S_UGRAT2] = true,
	[S_UGRAT3] = true,
	[S_UGRAT4] = true,
})



states[S_UGRAT1] = {
	sprite = SPR_PLAY,
	frame = SPR2_UGD1|FF_ANIMATE,
	var1 = 24,
	var2 = 2,
	tics = 24*2,
	nextstate = S_UGRAT2
}
states[S_UGRAT2] = {
    sprite = SPR_PLAY,
    frame = SPR2_UGD2|FF_ANIMATE,
    var1 = 24,
    var2 = 2,
	tics = 24*2,
    nextstate = S_UGRAT3
}
states[S_UGRAT3] = {
    sprite = SPR_PLAY,
    frame = SPR2_UGD3|FF_ANIMATE,
    var1 = 24,
    var2 = 2,
	tics = 24*2,
    nextstate = S_UGRAT4
}
states[S_UGRAT4] = {
    sprite = SPR_PLAY,
    frame = SPR2_UGD4|FF_ANIMATE,
    var1 = 14,
    var2 = 2,
	tics = 14*2,
    nextstate = S_UGRAT1
}

local function SpawnDancing(obj)
	if leveltime%P_RandomRange(2,5) == 0
		local r = P_RandomRange(-50,50)*FU
		local thok = P_SpawnMobjFromMobj(obj, 0, 0, P_RandomRange(0,40), MT_THOK)
		thok.tics = 1*TICRATE/2 -- .5 seconds
		thok.sprite = SPR_UBOB
		thok.destscale = $/3
		thok.scalespeed = FU/9
		thok.frame = P_RandomRange(1,6)
		thok.angle = FixedAngle(P_RandomRange(-360,360)*FU)
		P_InstaThrust(thok, thok.angle, 20*FU)
		P_SetObjectMomZ(thok, rando(-20,20)*FU)
		if obj.eflags & MFE_VERTICALFLIP
			thok.flags = $|MFE_VERTICALFLIP
		end
	end
end


addHook("PlayerMsg", function(p, t, _, msg)
    if p and p.valid
        and p.playerstate == PST_LIVE
        and p.mo.skin == UG
		and p.panim == PA_IDLE
		and t == 0
        and DanceString(msg)
		S_StopSoundByID(p.mo, sfx_ugyap)
		S_ChangeMusic(rando("ugov", "ugad", "ugps", "ugdv"),true,p)
		p.hasExecutedOnceForNonNapping = false
		p.mo.state = S_UGRAT1
    end
end)

addHook("PlayerThink", function(p)
    if p.mo and p.mo.valid
        and p.mo.skin == UG
        and (uglyratstate[p.mo.state] ~= true)
        if p.stopRatMusic == false then
			P_RestoreMusic(p)
            p.stopRatMusic = true
        end
    else
        p.stopRatMusic = false 
    end
end)

addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid
		and p.mo.skin == UG
		and uglyratstate[p.mo.state]
		and p.rmomx ~= 0 and p.rmomy ~= 0
		p.mo.state = S_PLAY_FALL
		P_RestoreMusic(p)
	end
end)
addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid
		and p.mo.skin ~= UG
		and uglyratstate[p.mo.state]
		p.mo.state = S_PLAY_FALL
		P_RestoreMusic(p)
	end
end)

