--thanks to motdspork for their peelout script

freeslot("SPR_UGPL", "SPR2_UGMO", "S_UGLY_PEEL")

states[S_UGLY_PEEL] = {
	sprite = SPR_PLAY,
	frame = SPR2_UGMO|FF_ANIMATE, -- mo for like dashMOde
	var1 = 3,
	var2 = 1,
	nextstate = S_UGLY_PEEL
}


addHook("ThinkFrame", do
	for player in players.iterate
		if (player and player.mo and player.mo.valid) and (player.mo.skin == UG)
			if player.mo.state == S_UGLY_PEEL
				for i = -40, 40
					
					local force = i*FRACUNIT/3
					local angle = ANGLE_90

					local shiftx = FixedMul(cos(player.drawangle + angle), force)
					local shifty = FixedMul(sin(player.drawangle + angle), force)
					
					local shiftx2 = FixedMul(cos(player.drawangle), FRACUNIT)
					local shifty2 = FixedMul(sin(player.drawangle), FRACUNIT)
					
					if i > 20
					or i < -20
						local peelout = P_SpawnMobjFromMobj(player.mo, shiftx2 + shiftx, shifty2 + shifty, 0, MT_OVERLAY)
						peelout.target = player.mo
						peelout.color = player.mo.color
						peelout.fuse = 1
						peelout.sprite = SPR_UGPL
						if i < 0
							if player.mo.frame == A|FF_ANIMATE
								peelout.frame = A
							elseif player.mo.frame == B|FF_ANIMATE
								peelout.frame = B
							elseif player.mo.frame == C|FF_ANIMATE
								peelout.frame = C
							elseif player.mo.frame == D|FF_ANIMATE
								peelout.frame = D
							end
							peelout.angle = player.drawangle + ANGLE_90/6
						else
						if player.mo.frame == A|FF_ANIMATE
								peelout.frame = A
							elseif player.mo.frame == B|FF_ANIMATE
								peelout.frame = B
							elseif player.mo.frame == C|FF_ANIMATE
								peelout.frame = C
							elseif player.mo.frame == D|FF_ANIMATE
								peelout.frame = D
							end
							peelout.angle = player.drawangle - ANGLE_90/6
						end
						peelout.renderflags = RF_PAPERSPRITE
						peelout.scale = player.mo.scale/2
						if player.mo.eflags & MFE_VERTICALFLIP
							peelout.eflags = $ | MFE_VERTICALFLIP
							peelout.z = player.mo.z + player.mo.height - peelout.height
						end
					end
				end
			end
		end
	end
end)

local function WalkState(player)
    local p = player
    if player.mo and player.mo.valid and player.mo.skin == UG and player.speed < 110*player.mo.scale then
        if p.mo.state == S_UGLY_PEEL then
            if not p.executed then
                p.mo.state = S_PLAY_WALK
                p.executed = true
            end
        end
    else
        p.executed = false
    end
end

addHook("PlayerThink", WalkState)

addHook("PlayerThink", function(p)
    if p.mo and p.mo.valid
        and p.mo.skin == UG
        if p.speed >= 110*p.mo.scale
            if leveltime%2 == 0
                CreateWind(p)
            end
            if (p.panim == PA_DASH) and (not p.powers[pw_super])
                p.mo.state = S_UGLY_PEEL
            end
        end
    end
end)
