rawset(_G, "NotPizza", function(thing)
    -- making sure that you can't ram into pizzaface for spice runners because i find that annoying (probably fixed by now but meh who cares)
    if PTSR and thing.type == MT_PIZZA_ENEMY then
        return false
    else
        return true
    end
end)

freeslot("MT_UGLY_RAGDOLL","sfx_ugme1","sfx_ugme2", "sfx_ugme3", "sfx_ugme4", "sfx_ugme5", "sfx_ugme6")

sfxinfo[sfx_ugme1].caption = "goofy ahh death scream"
sfxinfo[sfx_ugme2].caption = "goofy ahh death scream"
sfxinfo[sfx_ugme3].caption = "goofy ahh death scream"
sfxinfo[sfx_ugme4].caption = "goofy ahh death scream"
sfxinfo[sfx_ugme5].caption = "goofy ahh death scream"
sfxinfo[sfx_ugme6].caption = "goofy ahh death scream"
--aint no way im making these have different captions

rawset(_G, "battleLoaded", false)

addHook("ThinkFrame", function()--battlemod support i think
	if not battleLoaded
		and CBW_Battle
		battleLoaded = true
	end
end)

		
addHook("PlayerSpawn", function(p)
	p.ugf = false
end)


rawset(_G, "Random", function(...)
	local things = {...}
	return things[P_RandomRange(1, #things)]
end)

rawset(_G, "P_RandomMemeSound", function(thing)
	S_StartSound(thing, Random(sfx_ugme1, sfx_ugme2, sfx_ugme3, sfx_ugme4, sfx_ugme5, sfx_ugme6))
end)

rawset(_G, "P_SpawnRealExplosion", function(enemy)-- spawns an explosion png and plays a funni sound
	local ex = P_SpawnMobjFromMobj(enemy, 0, 0, 0, MT_THOK)
    ex.state = S_UGLY_EXPLOSION
    ex.scale = enemy.scale
	ex.spritexscale = $ + 4*FU
	ex.spriteyscale = $ + 4*FU
	ex.dispoffset = 30
    S_StartSound(ex, sfx_ugbo)
	return explosion
end)

rawset(_G, "P_SpawnExplosion", function(enemy)-- spawns an explosion like the uhhh tnt in Arid Canyon and plays the armageddon shield sound
	local explosion = P_SpawnMobjFromMobj(enemy, 0, 0, 0, MT_THOK)
	explosion.state = S_TNTBARREL_EXPL4
    explosion.scale = enemy.scale
    S_StartSound(enemy, sfx_bkpoof)
	return explosion
end)

rawset(_G, "ErasePlayer", function(p)
	local lol = P_SpawnRealExplosion(p.mo)
	
	p.mo.flags2 = $|MF2_DONTDRAW
	p.mo.momx = 0
	p.mo.momy = 0
	p.ugf = false
end)
	

addHook("PlayerThink", function(p)
	if p.pfuse --pfuse means player fuse since fuse doesnt work on a player i thinj
		p.pfuse = $ - 1
		else
		if p.ugf
			ErasePlayer(p)
		end
	end
end)
	
addHook("PlayerThink", function(p)
	if p.ugf and P_IsObjectOnGround(p.mo)
		ErasePlayer(p)
	end
end)
	
addHook("MobjMoveBlocked", function(pmo)
	if pmo.valid and pmo.player.ugf
		ErasePlayer(pmo.player)
	end
end, MT_PLAYER)

local function CanRam(mo1, mo2)
    if (G_CoopGametype() and CV_FindVar("friendlyfire").value == 0) then
        return false
    end
    if (G_RingSlingerGametype() or (G_CoopGametype() and CV_FindVar("friendlyfire").value == 1) or (battleLoaded == true and (not G_CoopGametype()))) then
        if (G_GametypeHasTeams() and mo1.player.ctfteam == mo2.player.ctfteam) then
            return false
        end
        if mo2.player.powers[pw_flashing] then
            return false
        end -- we wanna be fair dont we
        if mo2.player.powers[pw_super] then
            return false
        end
        if mo2.player.playerstate ~= PST_LIVE then
            return false
        end
        if mo1.skin ~= UG then
            return false
        end
		if mo1.state == S_UGLY_SKEDADDLE then
			return false
		end
        if mo1.player.dashmode < 3*TICRATE then
            return false
        end
        if mo2.player.powers[pw_invulnerability] then
            return false
        end
        if mo2.player.pflags & PF_GODMODE then
            return false
        end
        return true
    end
    return false
end
	
local function RamGuy(mo1, mo2)
    if mo2 and mo2.valid and mo2.player and mo2.player.valid
        and CanRam(mo1, mo2)
        and L_ZCollide(mo1, mo2) then
        BaseAngle(mo1.player, mo2)
        if mo2.player.powers[pw_shield] == SH_NONE then
            BaseAngle(mo1.player, mo2)
            P_KillMobj(mo2, mo1, mo1)
            mo2.state = S_PLAY_PAIN
            mo2.player.pfuse = 2 * TICRATE
            P_SpawnRealExplosion(mo2)
			mo2.z = $ + 5*FU
            P_InstaThrust(mo2, mo2.angle + (FixedAngle(P_RandomRange(-10, 10) * FU)), (P_RandomRange(15, 22) * FU + mo1.player.speed) / (3 / 2))
            P_SetObjectMomZ(mo2, P_RandomRange(15, 22) * FU, true)
			print(mo1.player.name+" just ran into "+mo2.player.name+"!")
            mo2.player.ugf = true --ugf is short for uglyflung-player
            if not battleLoaded then -- we dont want to add the score of killing a player in battlemod do we
                P_AddPlayerScore(mo1.player, 200)
            end
            P_RandomMemeSound(mo2)
        else
            P_DamageMobj(mo2, mo1, mo1)
            P_InstaThrust(mo2, mo2.angle, 30 * FU + mo1.player.speed)
            P_SetObjectMomZ(mo2, P_RandomRange(15, 22) * FU, true)
			print("Lucky "+mo2.player.name+". Their shield protected them from being ran over by "+mo1.player.name+"!")
        end
    end
end




addHook("MobjCollide", RamGuy, MT_PLAYER)
addHook("MobjMoveCollide", RamGuy, MT_PLAYER)

addHook("PlayerThink", function(p)
    if p.mo and p.mo.valid and p.ugf
		p.mo.rollangle = $ + FixedAngle(7*FU)
		if leveltime%10 == 0 then
			local ha = P_RandomRange(-50, 50)*FU
			local ragdust = P_SpawnMobjFromMobj(p.mo, ha, ha, ha, MT_BOSSEXPLODE)
			ragdust.scale = p.mo.scale
			
		end
    end
end)

mobjinfo[MT_UGLY_RAGDOLL] = {
	doomednum = -1,
	spawnstate = S_PLAY_STND
}

rawset(_G, "P_SpawnRagdoll", function(enemy, sound)-- this function spawns a ragdoll, the sound part is if the ragdoll should scream (i did this because i could use this function on trees and stuff and trees dont scream i think)
	local ragdoll = P_SpawnMobjFromMobj(enemy, 0, 0, 10*FU, MT_UGLY_RAGDOLL)
	ragdoll.scale = enemy.scale
	ragdoll.fuse = 2*TICRATE
	ragdoll.colorized = enemy.colorized
	ragdoll.blendmode = enemy.blendmode
	ragdoll.height = enemy.height
	ragdoll.radius = enemy.radius
	ragdoll.color = enemy.color
	ragdoll.angle = enemy.angle
	ragdoll.spritexscale = enemy.spritexscale
	ragdoll.spriteyscale = enemy.spriteyscale
	if enemy.sprite == SPR_PLAY then -- wtfsonic support
		ragdoll.skin = enemy.skin
		ragdoll.state = S_PLAY_DEAD
		else
		ragdoll.sprite = enemy.sprite
		ragdoll.frame = enemy.frame
	end
	if sound == nil
		sound = true
	end
	if sound == true
		P_RandomMemeSound(ragdoll)
	end
	return ragdoll
end)



addHook("MobjThinker", function(doll)
    local ragdoll = doll
    if doll and doll.valid
	doll.rollangle = $ + FixedAngle(7*FU)
	if leveltime%10 == 0 then
		local ha = P_RandomRange(-50, 50)*FU
		local ragdust = P_SpawnMobjFromMobj(ragdoll, ha, ha, ha, MT_BOSSEXPLODE)
        ragdust.scale = doll.scale
    end
        if P_IsObjectOnGround(doll) and doll.valid
            P_SpawnRealExplosion(doll)
            P_RemoveMobj(doll)
        end
    end
end, MT_UGLY_RAGDOLL)

addHook("MobjMoveBlocked", function(doll)
	local ragdoll = doll
	if doll and doll.valid
		P_SpawnRealExplosion(doll)
        P_RemoveMobj(doll)
	end
end, MT_UGLY_RAGDOLL)
	

addHook("MobjFuse", function(doll)
    local ragdoll = doll
    if doll and doll.valid
		 P_SpawnRealExplosion(doll)
         P_RemoveMobj(doll)
	end
end, MT_UGLY_RAGDOLL)

local function enemyCollide(enemy, pmo)
    if not (enemy.flags & MF_ENEMY) then return end
    if enemy.flags & MF_BOSS then return end -- making SURE we arent doing this to a BOSS!!!!!!!!!!!!!!!!!!!!!!!! (except fang cuz he weak i think)
    if not (enemy and enemy.valid) then return end 
    if enemy.health < 1 then return end
    if not L_ZCollide(enemy, pmo) then return end
    if enemy.flung then return end
    if NotPizza(enemy) == false then return end
    if pmo.momx == 0 and pmo.momy == 0 then return end
    if pmo.player and pmo.player.valid and pmo.skin == UG and pmo.player.dashmode > 3*TICRATE and pmo.player.playerstate == PST_LIVE then
        P_SpawnExplosion(enemy)
        local ragdoll = P_SpawnRagdoll(enemy, true)
        BaseAngle(pmo.player, enemy)
        P_InstaThrust(ragdoll, enemy.angle + (FixedAngle(P_RandomRange(-10,10)*FU)), (P_RandomRange(15,22)*FU + pmo.player.speed)/(3/2))
        P_SetObjectMomZ(ragdoll, P_RandomRange(15,22)*FU, true)
        enemy.flags2 = $|MF2_DONTDRAW
        enemy.flung = true
        P_KillMobj(enemy, pmo, pmo)
        if enemy and enemy.valid then
            P_SetOrigin(enemy, 999999*FU, 999999*FU, 999999*FU)
        end
    end
end

	
addHook("MobjCollide", enemyCollide)
addHook("MobjMoveCollide", enemyCollide)

local instantRam = {
	[MT_ROSY] = true,
	[MT_EGGROBO1] = true,
	[MT_EGGMOBILE4_MACE] = true,
	[MT_FANG] = true, --tbh fang looks weak to me soooooooooo
	[MT_SMALLMACE] = true,
	[MT_BIGMACE] = true
}

local function InstantClap(enemy, pmo)
    if pmo and pmo.valid and pmo.player and (pmo.momx ~= 0 or pmo.momy ~= 0) and pmo.valid and pmo.skin == UG and pmo.player.dashmode > 3*TICRATE and pmo.player.playerstate == PST_LIVE and instantRam[enemy.type] == true and L_ZCollide(pmo, enemy) then
        P_SpawnExplosion(enemy)
		local sound = true
		if enemy.type == MT_EGGMOBILE4_MACE or enemy.type == MT_SMALLMACE or enemy.type == MT_BIGMACE
			sound = false
		end
        local ragdoll = P_SpawnRagdoll(enemy, sound)
        BaseAngle(pmo.player, enemy)
        P_InstaThrust(ragdoll, enemy.angle + (FixedAngle(P_RandomRange(-10,10)*FU)), (P_RandomRange(15,22)*FU + pmo.player.speed)/(3/2))
        P_SetObjectMomZ(ragdoll, P_RandomRange(15,22)*FU, true)
        enemy.flags2 = $|MF2_DONTDRAW
        enemy.flung = true
        P_KillMobj(enemy, pmo, pmo)
        if enemy and enemy.valid then
            P_SetOrigin(enemy, 999999*FU, 999999*FU, 999999*FU)
        end
    end
end
addHook("MobjCollide", InstantClap)
addHook("MobjMoveCollide", InstantClap)
local function treeCollide(tree, pmo)--dont tell #teamtrees i did this
	if not (tree and tree.valid) then return end
	if not L_ZCollide(tree, pmo) then return end
	if tree.flags & MF_SCENERY and tree.flags & MF_SOLID then
		if tree.flung then return end
		if pmo.player and pmo.player.valid and pmo.skin == UG and pmo.player.dashmode > 3*TICRATE and pmo.player.playerstate == PST_LIVE then
			P_SpawnExplosion(tree)
			S_StartSound(pmo, sfx_bkpoof)
			BaseAngle(pmo.player, tree)
			local ragdoll = P_SpawnRagdoll(tree, false)
			P_InstaThrust(ragdoll, tree.angle + (FixedAngle(P_RandomRange(-10,10)*FU)), (50*FU + pmo.player.speed)/(5/2))
			P_SetObjectMomZ(ragdoll, P_RandomRange(10,15)*FU, true)
			tree.flags2 = $|MF2_DONTDRAW
			tree.flung = true
			P_AddPlayerScore(pmo.player, 100)
			P_RemoveMobj(tree)
		end
	end
end

addHook("MobjCollide", treeCollide)
		
