
--no speed cap WHEN in dashmode

CV_RegisterVar({
	name = "ugly_nerfspeed",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
})

local function P_CanIncreaseSpeed(p)
	if p.savedSpeed == nil then return true end
	if p.mo.state ~= S_UGLY_BREAK then return true end
	return false
end

rawset(_G, "G_FightGameMode", function()
	if (G_RingSlingerGametype() or G_GametypeHasTeams()) or (battleLoaded and (not G_CoopGametype())) then return true end
	return false
end)

addHook("PlayerThink", function(p)
    if p.mo and p.mo.valid and p.mo.skin == UG then
        if p.speed >= 100*p.mo.scale and P_CanIncreaseSpeed(p) then
            if CV_FindVar("ugly_nerfspeed").value == 0 then
                if leveltime%5 == 0 then
                    p.normalspeed = $ + 1*FU
                end
            else
                if not (G_RingSlingerGametype() or battleLoaded) then
                    if leveltime%5 == 0 then
                        p.normalspeed = $ + 1*FU
                    end
                end
            end
        end
    end
end)
	
	
local ugly_nerfspeed_enabled = false

addHook("PlayerThink", function(p)
    if p.mo and p.mo.valid and p.mo.skin == UG and CV_FindVar("ugly_nerfspeed").value == 0 and G_FightGameMode() then
        if not ugly_nerfspeed_enabled then
            p.normalspeed = skins["ugly"].normalspeed
            ugly_nerfspeed_enabled = true
        end
    else
        ugly_nerfspeed_enabled = false
    end
end)

	
addHook("PlayerThink", function(p)
    if p.mo and p.mo.valid and p.mo.skin == UG
        and CV_FindVar("ugly_nerfspeed").value == 1 and (G_RingSlingerGametype() or battleLoaded) then
        if p.speed >= 50*FU and p.mo.state ~= S_PLAY_GLIDE then
			p.normalspeed = 55*FU
        end
    end
end)


addHook("PlayerThink", function(p)
    if p.mo and p.mo.valid and p.mo.skin == UG then
        if p.speed < 100*p.mo.scale and p.dashmode < 3*TICRATE then
            if not p.mo.hasSpeedAdjusted then
                p.normalspeed = skins["ugly"].normalspeed
                p.mo.hasSpeedAdjusted = true
            end
        else
            p.mo.hasSpeedAdjusted = false
        end
    end
end)
