local function P_CanUglyScream(p)
    if p.ugf or p.uglycake then
        return false
    else
        return true
    end
end

freeslot("sfx_ugow", "sfx_ugde")

sfxinfo[sfx_ugow].caption = "AAAAAAAAA"
sfxinfo[sfx_ugow].flags = SF_X4AWAYSOUND
sfxinfo[sfx_ugde].caption = "HSFHSKASHEFASUJKEKASE"
sfxinfo[sfx_ugde].flags = SF_X4AWAYSOUND|SF_X8AWAYSOUND|SF_X2AWAYSOUND

CV_RegisterVar({
    name = "ugly_lostmedia",
    defaultvalue = "Off",
    flags = CV_NETVAR,
    PossibleValue = CV_OnOff
})

rawset(_G, "TRANSTABLE", {
    [1] = FF_TRANS10,
    [2] = FF_TRANS20,
    [3] = FF_TRANS30,
    [4] = FF_TRANS40,
    [5] = FF_TRANS50,
    [6] = FF_TRANS60,
    [7] = FF_TRANS70,
    [8] = FF_TRANS80,
    [9] = FF_TRANS90
})

addHook("NetVars", function(n)
	TRANSTABLE = n($)
end)

addHook("PlayerThink", function(p)
    if p.mo and p.mo.valid
        and p.mo.skin == UG
        and p.painscream
        and P_CanUglyScream(p)
        local pmo = p.mo
        local explosion = P_SpawnMobjFromMobj(p.mo,0, 0, 0, MT_THOK)
        explosion.state = S_TNTBARREL_EXPL4
        explosion.scale = pmo.scale
        S_StartSound(pmo, sfx_bkpoof)
        local dust = P_SpawnMobjFromMobj(p.mo,0, 0, 0, MT_TNTDUST)
        dust.scale = pmo.scale
        dust.spritexscale = 2*FU
        dust.spriteyscale = 2*FU
        S_StartSound(pmo, sfx_ugow)
        P_SetObjectMomZ(pmo, 50*FU, true)
        P_Thrust(pmo, pmo.angle, -50*FU)
        p.painscream = false
    end
end)

addHook("MobjDamage", function(pmo)
    if pmo.skin == UG and pmo.player.playerstate == PST_LIVE
        and pmo.player.rings ~= 0
        and pmo.player.screm ~= true
        and P_CanUglyScream(pmo.player)
        if S_SoundPlaying(pmo, sfx_ugow) then return end
        local chance = P_RandomChance(FRACUNIT/10) -- 10% chance to do the scream when hurt
        if chance == true then
            pmo.player.painscream = true
        end
    end
end)

addHook("MobjDeath", function(pmo)
    if pmo.skin == UG and pmo.player then
        if pmo.player.screm then return end
        
        local chance = false
        
        if CV_FindVar("ugly_lostmedia").value == 1 then
            chance = true
            if not P_CanUglyScream(pmo.player) then
                chance = false
            end
        else
            chance = P_RandomChance(FRACUNIT/20) -- 5% chance to scream when dead
        end
        
        if chance == true then
            pmo.player.screm = true -- imma carry this onto a playerthink
            pmo.player.charflags = pmo.player.charflags & ~SF_MACHINE -- i dont want the explosions showing 
        end
    end
end)

addHook("ThinkFrame", function()
    for p in players.iterate do
        if p.mo and p.mo.valid
            and p.mo.skin == UG
            and p.playerstate == PST_DEAD
            and P_CanUglyScream(p)
            and p.screm then
            p.mo.momz = 0
            if p.mo.state ~= S_PLAY_DRWN then
                p.mo.state = S_PLAY_DRWN
                p.ttable = 1
                p.timedown = 20
                S_StartSound(pmo, sfx_ugde)
                p.mo.colorized = true
                p.mo.color = SKINCOLOR_BLACK
            end
            if p.screm then
                if p.timedown then
                    p.timedown = p.timedown - 1
                     p.mo.momz = 0
                     P_SetObjectMomZ(p.mo,1*FU)
                else
                    p.ttable = p.ttable + 1
                    P_SetObjectMomZ(p.mo,1*FU)
                end
            end
        end
    end
end)

addHook("PlayerThink", function(p)
    if p.mo and p.mo.valid
        and p.mo.skin == UG
        and p.playerstate == PST_DEAD
        and P_CanUglyScream(p)
        and p.screm then
        if p.ttable < 10
            p.mo.frame = $|TRANSTABLE[p.ttable]
            else
            p.mo.flags2 = $|MF2_DONTDRAW
        end
    end
end)
        
addHook("PlayerThink", function(p)--ight heres the playerthinj
    p.ttable = $ or 1
    if p.mo and p.mo.valid
        and p.mo.skin == UG
        and p.screm
        and P_CanUglyScream(p)
        and p.playerstate == PST_LIVE
        p.screm = false
        p.ttable = 1
        p.timecool = 20
        p.charflags = $|SF_MACHINE
    end
end)