freeslot("S_UGLY_SKEDADDLE","sfx_ugok","sfx_ugdad")--dad is short for skedaddle

local dadl = S_UGLY_SKEDADDLE





states[dadl] = {
	sprite = SPR_PLAY,
	frame = SPR2_WALK|FF_ANIMATE,
	var1 = 8,
	var2 = 1,
	nextstate = dadl
}

sfxinfo[sfx_ugdad].caption = "goofy ahh skedaddle"

addHook("ThinkFrame", function()
    for p in players.iterate do
        if (p.pflags & PF_STASIS or p.pflags & PF_JUMPSTASIS) then
            p.uglyisfrozen = true
        else
            p.uglyisfrozen = false
        end
    end
end)
		

local function CantSkedaddle(p)
	if (p.isSpawningIn) then return true end
	if p.exiting then return true end
	if (p.uglyisfrozen) then return true end
	return false
end
		

sfxinfo[sfx_ugok].caption = "ULTIMATE CHARGE RAHHHHH"
addHook("PlayerSpawn", function(p)
	p.stime = 0
end)

addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid
		and p.mo.skin == UG
		and p.mo.state == S_UGLY_SKEDADDLE
		and CantSkedaddle(p)
		p.mo.state = S_PLAY_FALL
	end
end)


addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid
		and p.mo.skin == UG
		and p.mo.state ~= S_UGLY_SKEDADDLE
		and p.cmd.buttons & BT_CUSTOM1
		and p.panim == PA_IDLE
		and p.speed <= 0
		
		and p.playerstate == PST_LIVE
		and P_IsObjectOnGround(p.mo)
		and CantSkedaddle(p) == false
		if p.powers[pw_shield] ~= SH_ATTRACT
			p.normalspeed = 0
			S_StartSound(p.mo, sfx_ugdad)
			p.mo.state = dadl
		end
		if p.powers[pw_shield] == SH_ATTRACT
			S_StartSound(p.mo, sfx_ugok)
			p.mo.state = dadl
		end
		p.stime = 0
	end
end) 


addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid
		and p.mo.skin == UG
		and CantSkedaddle(p) == false
		and p.mo.state == S_UGLY_SKEDADDLE
		and p.playerstate == PST_LIVE
		if p.powers[pw_shield] == SH_ATTRACT
			if not S_SoundPlaying(p.mo, sfx_ugok)
				S_StartSound(p.mo, sfx_ugok)
			end
			p.dashmode = 4*TICRATE
			local r = P_RandomRange(-40,40)*FU
			local shock = P_SpawnMobjFromMobj(p.mo,r, r, r, MT_WATERZAP)
			shock.scale = p.mo.scale
			shock.spritexscale = 2*FU
			shock.spriteyscale = 2*FU
			if leveltime%10 == 0
				local gho = P_SpawnGhostMobj(p.mo)
				gho.color = SKINCOLOR_GOLD
				gho.frame = FF_TRANS10|FF_FULLBRIGHT
				gho.colorized = true
				gho.scale = p.mo.scale*2
				gho.destscale = p.mo.scale
				gho.scalespeed = FRACUNIT/12
			end
		end
		if p.stime < 100 and (not G_FightGameMode())
			p.stime = $ + 1
			elseif G_FightGameMode()
			if p.stime < 30
				p.stime = $ + 1
			end
		end
		if p.stime >= 100 then
			p.dashmode = 4*TICRATE
		end
		if p.powers[pw_shield] == SH_ATTRACT
			p.stime = 190
		end
		
		p.normalspeed = 0
		local dust = P_SpawnMobjFromMobj(p.mo,0, 0, 0, MT_SPINDUST)---uhhh this makes dust
		dust.scale = p.mo.scale
		
		if p.powers[pw_shield] == SH_ATTRACT
			dust.colorized = true
			dust.color = SKINCOLOR_YELLOW
		end
		P_InstaThrust(dust, p.drawangle + FixedAngle(P_RandomRange(-20,20)*FU), -P_RandomRange(10,15)*p.mo.scale)
		P_SetObjectMomZ(dust, P_RandomRange(2,5)*FU)
		if not S_SoundPlaying(p.mo, sfx_ugru)
			S_StartSound(p.mo, sfx_ugru)
		end
	end
end)

addHook("ThinkFrame", function(p)
	for p in players.iterate do
		if p.mo and p.mo.valid

			and p.mo.skin == UG
			and p.mo.state == S_UGLY_SKEDADDLE
			and not (p.cmd.buttons & BT_CUSTOM1)
			if p.stime > 40
				p.normalspeed = p.stime
			else
				p.normalspeed = skins[UG].normalspeed
			end
			P_Thrust(p.mo, p.drawangle, p.stime*p.mo.scale)
			p.speed = p.stime*FU
			p.mo.state = S_PLAY_FALL
			p.stime = 0
			p.sked = false
		end
	end
end)


addHook("PlayerThink", function(p)
    if p.mo and p.mo.valid and p.mo.skin == UG and CantSkedaddle(p) == false then
        if (p.mo.state ~= S_UGLY_SKEDADDLE or P_PlayerInPain(p)) then
            if not p.resetspeed then
                if p.stime > 40 then
                    p.normalspeed = p.stime*FU
                else
                    p.normalspeed = skins[UG].normalspeed
                end
                p.resetspeed = true
            end
        else
            p.resetspeed = false
        end
    end
end)


addHook("MobjDamage", function(pmo)
    if pmo.skin == UG and pmo.player and pmo.player.sked
		local p = pmo.player
		if p.stime > 40
				p.normalspeed = p.stime*FU
			else
				p.normalspeed = skins[UG].normalspeed
			end
		pmo.player.sked = false
	end
end)

