freeslot("sfx_ugwin", "S_UGLY_COYOTE", "sfx_ugsli")

sfxinfo[sfx_ugsli].caption = "goofy ahh slipping"

local dadl = S_UGLY_COYOTE

sfxinfo[sfx_ugwin].caption = "you win"

states[dadl] = {--deadass same thing as skedadle
	sprite = SPR_PLAY,
	frame = SPR2_WALK|FF_ANIMATE,
	var1 = 8,
	var2 = 1,
	nextstate = dadl
}

local function P_NearGroundLoL(player)
    local playerZ = player.mo.z
    local p = player
    local floorZ = player.mo.floorz

    if p.mo.eflags & MFE_VERTICALFLIP then
        floorZ = player.mo.ceilingz
    end

    if abs(playerZ - floorZ) <= 30*p.mo.scale then
		--print("si")
        return true -- Player is near the ground
    elseif abs(playerZ - floorZ) > 30*p.mo.scale then
		--print("no")
        return false -- Player is not near the ground
    end
end
addHook("PlayerThink", function(p)
	P_NearGroundLoL(p)
end)

addHook("PlayerThink", function(p)
    if p.mo and p.mo.valid and p.mo.skin == UG then
        if p.exiting then
            if not p.victoryScreech then
                S_StartSound(nil, sfx_ugwin)
				COM_BufInsertText(p, "tunes -none")
                p.victoryScreech = true
            end
        else
            p.victoryScreech = false
        end
    end
end)

local UglySpikes = {
    [MT_SPIKE] = true,
    [MT_WALLSPIKE] = true
}

local function SpikeCollide(spike, pmo)
    if pmo.player and pmo.valid and pmo.skin == UG and (pmo.player.powers[pw_super] or pmo.player.powers[pw_invulnerability] or pmo.state == S_UGLY_POUND) then
        if UglySpikes[spike.type] and L_ZCollide(spike, pmo) then
            P_KillMobj(spike, pmo, pmo)
        end
    end
end

addHook("MobjCollide", SpikeCollide)
addHook("MobjMoveCollide", SpikeCollide)

--i swear if ANYONE says i stole this from the Airwalk lua addon, im going to be VERY MAD

local coyotestates = {
	[S_PLAY_RUN] = true,
	[S_PLAY_DASH] = true,
	[S_UGLY_PEEL] = true
}

addHook("PlayerSpawn", function(p)
	p.uglysave = nil
end)

addHook("PlayerThink", function(player)
    if player.mo.skin == UG then
        if not P_IsObjectOnGround(player.mo) and player.uglysave == nil then
            player.uglysave = player.speed
			--print("eye")
        elseif P_IsObjectOnGround(player.mo) then
			player.uglyspeednow = player.uglysave
            player.uglysave = nil
        end
    end
end)

local function SpeedGreater(p)
	if p.uglysave ~= nil and p.uglysave > (40)*p.mo.scale
		return true
	end
	return false
end

addHook("PlayerSpawn", function(p)
	p.coyoteTime = 0
end)
	
addHook("PlayerThink", function(p)
	if P_IsObjectOnGround(p.mo)
		p.coyoteTime = 0
		p.coyoteStateTimer = 0
	end
end)
addHook("PlayerThink", function(player)
    if player.coyoteTime == nil and player.mo.skin == UG then
        player.coyoteTime = 0
		player.cantdowindjumpbecauseifyoudothenyouwontbeabletousethebirdability = 0
    end
    local p = player
    if (player.mo.eflags & MFE_UNDERWATER)
        or (player.mo.eflags & MFE_SPRUNG)
        or player.mo.state == S_PLAY_ROLL
        or player.mo.state == S_PLAY_PAIN
		or SpeedGreater(p) == false
        or player.mo.state == S_UGLY_SCREM
        or P_IsObjectInGoop(p.mo)
        return
    end

    if player.coyoteAllowed == nil then
        player.coyoteAllowed = true
    end
    if player.coyoteStateTimer == nil then
        player.coyoteStateTimer = 0
    end

    local isOnGround = P_IsObjectOnGround(player.mo)

    if (isOnGround or P_NearGroundLoL(player)) and p.mo.skin == UG then
        player.coyoteAllowed = true
        player.coyoteStateTimer = 0
		if p.mo.state == S_UGLY_COYOTE
			p.mo.state = S_PLAY_FALL
		end
        player.savedSpeed = nil
        if player.normalspeedSet == nil and (player.coyoteTime > 0 and player.coyoteTime < 2*TICRATE) then
            if p.speed > 41*p.mo.scale
				player.normalspeed = p.speed
			else
				p.normalspeed = skins[UG].normalspeed
			end
            player.normalspeedSet = true
            player.coyoteTime = 0
        end
    else
        player.normalspeedSet = nil
    end

    if not isOnGround and coyotestates[p.mo.state] and player.coyoteAllowed and p.mo.skin == UG and (not (player.pflags & PF_JUMPED)) then
        player.coyoteTime = player.coyoteTime + 1

        if player.coyoteTime > 2*TICRATE then
            player.coyoteAllowed = false
            if coyotestates[p.mo.state] then
                p.mo.state = S_PLAY_GASP
                S_StartSound(p.mo, sfx_ugsli)
                player.mo.state = S_UGLY_COYOTE
                player.normalspeed = skins[UG].normalspeed
            end
        end
        if player.dashmode < 3*TICRATE then
			
            player.dashmode = 0
        end
        if not (isOnGround or P_NearGroundLoL(player)) then
				player.cantdowindjumpbecauseifyoudothenyouwontbeabletousethebirdability = 5
                player.mo.momz = 0
            end
        if player.coyoteTime > 0 and player.savedSpeed == nil and not (isOnGround or P_NearGroundLoL(player)) then
            player.savedSpeed = player.speed
            player.normalspeed = player.savedSpeed
        end
    end

    if p.mo.skin == UG and isOnGround and player.coyoteTime > 0 then
        player.coyoteTime = 0
		p.coyoteStateTimer = 0
    end

    if player.mo.state == S_UGLY_COYOTE and p.mo.skin == UG then
        player.coyoteStateTimer = player.coyoteStateTimer + 1
        player.mo.momx = 0
        player.mo.momy = 0
        player.mo.momz = 0
        if player.coyoteStateTimer >= 2*TICRATE then
            player.mo.state = S_PLAY_PAIN
            S_StartSound(p.mo, sfx_s3k51)
            P_RandomMemeSound(p.mo)
            player.coyoteStateTimer = 0
        end
    end

    if player.cmd.buttons & BT_JUMP and player.playerstate == PST_LIVE and player.coyoteTime > 0 and player.mo.state ~= S_PLAY_PAIN and player.mo.state ~= S_UGLY_COYOTE then
        P_DoJump(player, true)
		p.cantdowindjumpbecauseifyoudothenyouwontbeabletousethebirdability = 5
		player.coyoteTime = 0
		p.coyoteStateTimer = 0
        player.coyoteAllowed = false
         if p.speed > 41*p.mo.scale
			player.normalspeed = p.speed
		else
			p.normalspeed = skins[UG].normalspeed
		end
        player.coyoteTime = 0
        player.coyoteAllowed = false
    end
	if p.cantdowindjumpbecauseifyoudothenyouwontbeabletousethebirdability then
		p.cantdowindjumpbecauseifyoudothenyouwontbeabletousethebirdability = $ - 1
	end
end)