freeslot("sfx_ugmic","SPR2_UGMI","S_UGLY_WAVE")

sfxinfo[sfx_ugmic].caption = "MUSIC TO MY EARS"



states[S_UGLY_WAVE] = {
	sprite = SPR_PLAY,
	frame = SPR2_UGMI
}

addHook("PlayerMsg", function(p, _, _, msg)
    if p and p.valid
        and p.playerstate == PST_LIVE
        and p.mo.skin == UG
		and p.panim == PA_IDLE
        and string.lower(msg) == string.lower("microwave")
        S_StartSound(p.mo, sfx_ugmic)
		S_StopSoundByID(p.mo, sfx_ugyap)
		p.mo.state = S_UGLY_WAVE
		S_StopSoundByID(p.mo, sfx_ugyap)
		return true
    end
end)


addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid
		and p.mo.skin == UG
		and p.mo.state ~= S_UGLY_WAVE
		S_StopSoundByID(p.mo, sfx_ugmic)
	end
end)

addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid
		and p.mo.skin == UG
		and p.mo.state == S_UGLY_WAVE
		if not S_SoundPlaying(p.mo, sfx_ugmic)
			S_StartSound(p.mo, sfx_ugmic)
		end
	end
end)

addHook("PlayerThink", function(p)
	if p.mo and p.mo.valid
		and p.mo.skin == UG
		and p.mo.state == S_UGLY_WAVE
		and p.rmomx ~= 0 and p.rmomy ~= 0
		p.mo.state = S_PLAY_FALL
	end
end)
	
			